// Julia4MT.cpp:      DLL.
//

#include "stdafx.h"
#include "Julia4MT.h"

#include <thread>
#include <mutex>


static int jmt_instances = 0;	///   -  //  julia_OnInit
static int jmt_exit_flag = 0; ///   1    

static std::mutex jmt_mutex;	///   :-( 

static int jmt_dll_init();	///  ,    OnInit
static int jmt_dll_done();	///  -,    OnDeinit   jmt_exit_flag



JMT_API(MT_INT) jmt_Hello() 
{
	return 775;
}
/** ,  //  OnInit()
	    OnInit      julia_dll_init
	    instances
**/
JMT_API(MT_INT) jmt_OnInit()
{
	//         
	//    
	std::lock_guard<std::mutex> lock(jmt_mutex);
	if (jmt_instances == 0) {
		jmt_dll_init();
	}
	jmt_instances++;
	return 0;
}
/** -,  //  OnDeinit()
	   instances,
	    julia_dll_done
**/
JMT_API(void) jmt_OnDeInit(const MT_INT reason)
{
	std::lock_guard<std::mutex> lock(jmt_mutex);
	if (reason == REASON_CLOSE) {
		jmt_exit_flag = 1;
	}
	jmt_instances--;
	if (jmt_exit_flag && jmt_instances == 0) {
		jmt_dll_done();
	}
	return;
}
/**    
	@arg utf8 -      UTF8
	@arg nbytes -     ,   \0
	@arg ret_store -       (jl_value_t *)
	@return  , 0   
**/
JMT_API(MT_INT) jmt_eval(char *utf8, MT_INT nbytes,jl_value_t **ret_store)
{
	jl_value_t *ret = NULL;
	if (utf8 == 0 || nbytes < 2) {
		return -1;
	}
	std::lock_guard<std::mutex> lock(jmt_mutex);
	ret = jl_eval_string(utf8);
	if (ret_store != NULL) {
		(*ret_store) = ret;
	}
	return 0;
}
/**    ,   double
	@arg utf8 -      UTF8
	@arg nbytes -     ,   \0
	@return    0  
**/
JMT_API(MT_DOUBLE) jmt_eval_double(char *utf8, MT_INT nbytes)
{
	if (utf8 == 0 || nbytes < 2) {
		return 0;
	}
	std::lock_guard<std::mutex> lock(jmt_mutex);
	jl_value_t *ret = jl_eval_string(utf8);
	if (ret == NULL) {
		return 0;
	}
	return jl_unbox_float64(ret);
}
/**    ,   long
	@arg utf8 -      UTF8
	@arg nbytes -     ,   \0
	@return    0  
**/
JMT_API(MT_LONG) jmt_eval_int(char *utf8, MT_INT nbytes)
{
	if (utf8 == 0 || nbytes < 2) {
		return 0;
	}
	std::lock_guard<std::mutex> lock(jmt_mutex);
	jl_value_t *ret = jl_eval_string(utf8);
	if (ret == NULL) {
		return 0;
	}
	return jl_unbox_int64(ret);
}

/**    double
    @arg value    Julia
    @return double   double.
    !!       0
**/
JMT_API(MT_DOUBLE) jmt_double(jl_value_t *value)
{
	if (value == NULL) {
		return EMPTY_VALUE;
	}
	std::lock_guard<std::mutex> lock(jmt_mutex);
	return jl_unbox_float64(value);
}
/**    long
    @arg value    Julia
    @return long   .
    !!       0
**/
JMT_API(MT_LONG) jmt_int(jl_value_t *value)
{
	if (value == NULL) {
		return 0;
	}
	std::lock_guard<std::mutex> lock(jmt_mutex);
	return jl_unbox_int64(value);
}

int jmt_dll_init()
{
	jl_init();	//   Julia
	return 0;
}

int jmt_dll_done()
{
	jl_atexit_hook(0);
	return 0;
}

