#ifndef JULIA4MT_H
#define JULIA4MT_H 1

#ifdef JULIA4MT_EXPORTS
#define JULIA4MT_API __declspec(dllexport)
#define JMT_API(type) __declspec(dllexport) type __cdecl
#else
#error "Wow"
#define JULIA4MT_API __declspec(dllimport)
#define JMT_API(type) __declspec(dllimport) type __cdecl
#endif

#include <stddef.h>
#include <stdint.h>
#include <julia.h>

#ifndef MT_VERSION
#define MT_VERSION 4
#endif

#if (MT_VERSION==4)
typedef int64_t MT_LONG;
typedef int32_t MT_INT;
#elif (MT_VERSION==5)
typedef int64_t MT_LONG;
typedef int64_t MT_INT;
#else
#error "unsupported MT version"
#endif
typedef double MT_DOUBLE;

//   -    julia_OnDeinit
enum DEINIT_REASON {
	REASON_PROGRAM=0, // 0
	REASON_REMOVE=1,
	REASON_RECOMPILE=2,
	REASON_CHARTCHANGE=3,
	REASON_CHARTCLOSE=4,
	REASON_PARAMETERS=5,
	REASON_ACCOUNT=6,
	REASON_TEMPLATE=7,
	REASON_INITFAILED=8,
	REASON_CLOSE=9
};
#define EMPTY_VALUE DBL_MAX

#ifdef __CPLUSPLUS__
extern "C" {
#endif

JMT_API(MT_INT) jmt_OnInit();
JMT_API(void) jmt_OnDeInit(const MT_INT reason);
JMT_API(MT_INT) jmt_Hello();

JMT_API(MT_INT)  jmt_eval(char *utf8, MT_INT nbytes, jl_value_t **);
JMT_API(MT_LONG) jmt_eval_int(char *utf8, MT_INT nbytes);
JMT_API(MT_DOUBLE) jmt_eval_double(char *utf8, MT_INT nbytes);
JMT_API(MT_DOUBLE) jmt_double(jl_value_t *);
JMT_API(MT_LONG) jmt_int(jl_value_t *);
#ifdef __CPLUSPLUS__
}
#endif

#endif