//+------------------------------------------------------------------+
//|                                                     Julia4MT.mq4 |
//|                                  Copyright 2018, Maxim Kuznetsov |
//|                                          https://www.luxtrade.tk |
//+------------------------------------------------------------------+
#property copyright "Maxim Kuznetsov"
#property link      "https://www.luxtrade.tk"
#property version   "1.00"
#property description "Embeddiing Julia (https://julialang.org) into MetaTrader"
#property strict


#define JMT_HANDLE uint

#import "c:\\forex\\alpari\\MQL4\\Libaries\\Julia4MT\\julia4mt.dll"
int jmt_Hello(void);
int jmt_OnInit(void);
void jmt_OnDeInit(int);
int jmt_eval(const char &[],int nbytes,JMT_HANDLE &);
double jmt_eval_double(const char &[],int nbytes);
long jmt_eval_int(const char &[],int nbytes);
long jmt_int(JMT_HANDLE);
double jmt_double(JMT_HANDLE);
#import


int
Julia_OnInit()
{
   Print("do calling jmt_OnInit()");
   return jmt_OnInit();
}

void
Julia_OnDeinit(const int reason)
{
   jmt_OnDeInit(reason);
}

int
Julia_Eval(const string equation,JMT_HANDLE &ret_store)
{
   uchar utf8[];
   if (StringToCharArray(equation,utf8,0,WHOLE_ARRAY,CP_UTF8)<2) {
      return -1;
   }
   return jmt_eval(utf8,ArraySize(utf8),ret_store);
}
long
Julia_EvalInt(const string equation) 
{
   uchar utf8[];
   if (StringToCharArray(equation,utf8,0,WHOLE_ARRAY,CP_UTF8)<2) {
      return -1;
   }
   return jmt_eval_int(utf8,ArraySize(utf8));
}
double
Julia_EvalDouble(const string equation) 
{
   uchar utf8[];
   if (StringToCharArray(equation,utf8,0,WHOLE_ARRAY,CP_UTF8)<2) {
      return -1;
   }
   return jmt_eval_double(utf8,ArraySize(utf8));
}
double
Julia_Double(JMT_HANDLE value)
{
   if (value==0) return 0.0;
   return jmt_double(value);
}
long
Julia_Int(JMT_HANDLE value)
{
   if (value==0) return 0;
   return jmt_int(value);
}

class Julia {
public:
   Julia();
   ~Julia();
   
   int Eval(const string equation,JMT_HANDLE &ret_store);
   double EvalDouble(const string equation);
   long EvalInt(const string equation);
   
   long Int(JMT_HANDLE); 
   double Double(JMT_HANDLE);
  
};

Julia::Julia(void) {
   Julia_OnInit();
}
Julia::~Julia(void) {
   Julia_OnDeinit(0);
}
int
Julia::Eval(const string equation,JMT_HANDLE &ret_store)
{
   return Julia_Eval(equation,ret_store);
}
double
Julia::EvalDouble(const string equation)
{
   return Julia_EvalDouble(equation);
}
long
Julia::EvalInt(const string equation)
{
   return Julia_EvalInt(equation);
}
double
Julia::Double(JMT_HANDLE value)
{
   return Julia_Double(value);
}
long
Julia::Int(JMT_HANDLE value)
{
   return Julia_Int(value);
}

